# remirepo/fedora spec file for php-nette-php-generator
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    78c898808d3a1018cc81f9d7108bc645129776c8
#global gh_date      20150728
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     nette
%global gh_project   php-generator
%global ns_vendor    Nette
%global ns_project   PhpGenerator
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.6.3
%global specrel 1
Release:        %{?gh_date:1%{specrel}.%{?prever}%{!?prever:%{gh_date}git%{gh_short}}}%{!?gh_date:%{specrel}}%{?dist}.1
Summary:        Nette PHP Generator

Group:          Development/Libraries
License:        BSD or GPLv2 or GPLv3
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{name}-%{version}-%{gh_short}.tgz
# pull a git snapshot to get test sutie
Source1:        makesrc.sh

BuildArch:      noarch
BuildRequires:  php-composer(theseer/autoload)
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pcre
BuildRequires:  php-reflection
BuildRequires:  php-composer(%{gh_owner}/utils)  >= 2.4.2
# From composer.json, "require-dev": {
#               "nette/tester": "^2.0",
#               "tracy/tracy": "^2.3"
# ignore tracy (pass without)
BuildRequires:  php-composer(%{gh_owner}/tester) >= 2.0
%endif

# from composer.json, "require": {
#               "php": ">=5.6.0",
#               "nette/utils": "^2.4.2 || ~3.0.0"
Requires:       php(language) >= 5.6
Requires:       php-composer(%{gh_owner}/utils) >= 2.4.2
Requires:       php-composer(%{gh_owner}/utils) <  4
# from phpcompatinfo report for version 2.3.4
Requires:       php-pcre
Requires:       php-reflection

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Generate PHP code with a simple programmatical API.

To use this library, you just have to add, in your project:
  require_once '%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: Generate a classmap autoloader
phpab --output src/%{ns_project}/autoload.php src

cat << 'EOF' | tee -a src/%{ns_project}/autoload.php
// Dependencies
require_once '%{php_home}/%{ns_vendor}/Utils/autoload.php';
EOF


%install
mkdir -p     %{buildroot}%{php_home}/%{ns_vendor}
cp -pr src/* %{buildroot}%{php_home}/%{ns_vendor}/


%check
%if %{with_tests}
export LANG=fr_FR.utf8

: Generate autoloader
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{php_home}/Tester/autoload.php';
require_once '%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';
EOF

: Run test suite in sources tree
ret=0
for cmd in php php56 php70 php71 php72; do
  if which $cmd; then
   $cmd %{_bindir}/nette-tester --colors 0 -p $cmd -C tests  -d serialize_precision=14 -s || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license license.md
%doc readme.md contributing.md
%doc composer.json
%{php_home}/%{ns_vendor}/%{ns_project}


%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.3-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Aug  6 2017 Remi Collet <remi@remirepo.net> - 2.6.3-1
- Update to 2.6.3

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.2-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon Mar 20 2017 Remi Collet <remi@remirepo.net> - 2.6.2-1
- Update to 2.6.2

* Wed Mar 15 2017 Remi Collet <remi@remirepo.net> - 2.6.1-1
- Update to 2.6.1

* Sun Feb 26 2017 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.0-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sun Jan 15 2017 Remi Collet <remi@fedoraproject.org> - 2.5.0-1
- update to 2.5.0

* Tue Aug  2 2016 Remi Collet <remi@fedoraproject.org> - 2.4.1-1
- update to 2.4.1
- raise dependency on PHP >= 5.6
- raise dependency on nette/utils >= 2.4

* Mon Jun 20 2016 Remi Collet <remi@fedoraproject.org> - 2.3.6-1
- update to 2.3.6

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.5-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Dec  3 2015 Remi Collet <remi@fedoraproject.org> - 2.3.5-1
- update to 2.3.5

* Tue Oct 20 2015 Remi Collet <remi@fedoraproject.org> - 2.3.4-1
- initial package